"""Fixtures for the tests"""

from dataclasses import replace
from typing import Callable
from unittest.mock import MagicMock

import dask.array as da
import numpy as np
import xarray as xr
import yaml
from distributed import Client, LocalCluster
from pytest import fixture

from ska_sdp_distributed_self_cal_prototype.data_managers.swiftly import Swiftly
from ska_sdp_distributed_self_cal_prototype.data_managers.visibility_bin import VisibilityBin
from ska_sdp_distributed_self_cal_prototype.data_managers.visibility_io import VisibilityPartition
from ska_sdp_distributed_self_cal_prototype.processing_tasks.gridding import Gridder
from ska_sdp_distributed_self_cal_prototype.workflow.pipeline_config import (
    ImageInfo,
    PhaseCenter,
    PipelineConfig,
    ProcessingSetInfo,
)

UVW_LABEL = np.array(["u", "v", "w"])


@fixture(scope="session")
def dask_client():
    cluster = LocalCluster(processes=True)
    yield Client(cluster)


@fixture(scope="function")
def config_file_odd_facets(tmp_path, dask_client) -> Callable:
    """Constructs a YAML config.

    The returned config specifies a swiftly config that has an odd number of facets along its edge.

    Returns:
        Function that generates the YAML config and returns the path of the dumped YAML. The returned function has
            the following arguments:
            parallel_cleaning: Option to control whether CLEAN is computed in parallel.
            output_filenames: Option to control whether the YAML contains the "output_filenames" key.
    """

    def make_config(parallel_cleaning: bool = False, output_filenames: bool = True) -> str:
        config = {
            "ps_dir": "tests/data/3C123_xradio_v0-0-41.ps",
            "dataset_key": "20B-356_Array_Kuband_calib_selfcal_14",
            "swiftly_config": "1k[1]-n512-512",
            "output_dir": str(tmp_path) + "/",
            "wtower_size": 100,
            "backwards_steps": 10,
            "forwards_steps": 10,
            "backward_queue_size": 10,
            "forward_queue_size": 10,
            "subgrid_size_effective": 10,
            "facet_count": 4,
            "facet_size_effective": 5,
            "pixel_scale": "0.08937164076118534asec",
            "parallel_cleaning": parallel_cleaning,
            "dask_address": dask_client.scheduler.address,
        }
        if output_filenames:
            config["output_filenames"] = {
                "psf_image": "test_psf_image",
                "dirty_image": "test_dirty_image",
                "clean_image": "test_clean_image",
                "intermediate_images": "test_partial_cleaned",
                "residual_image": "test_residual_image",
                "model_image": "test_model_image",
            }
        else:
            config["output_filenames"] = "use_default"
        config_filepath = tmp_path / "config.yaml"
        with open(config_filepath, "w") as outfile:
            yaml.dump(config, outfile)
        return config_filepath

    return make_config


@fixture(scope="function")
def config_file_even_facets(tmp_path, dask_client) -> Callable:
    """Constructs a YAML config.

    The returned config specifies a swiftly config that has an even number of facets along its edge.

    Returns:
        Function that generates the YAML config and returns the path of the dumped YAML. The returned function has
            the following arguments:
            parallel_cleaning: Option to control whether CLEAN is computed in parallel.
            output_filenames: Option to control whether the YAML contains the "output_filenames" key.
    """

    def make_config(parallel_cleaning: bool = False, output_filenames: bool = True):
        config = {
            "ps_dir": "tests/data/3C123_xradio_v0-0-41.ps",
            "dataset_key": "20B-356_Array_Kuband_calib_selfcal_14",
            "swiftly_config": "1k[1]-n1k-256",
            "output_dir": str(tmp_path) + "/",
            "wtower_size": 100,
            "backwards_steps": 10,
            "forwards_steps": 10,
            "backward_queue_size": 10,
            "forward_queue_size": 10,
            "subgrid_size_effective": 10,
            "facet_count": 4,
            "facet_size_effective": 5,
            "pixel_scale": "0.08937164076118534asec",
            "parallel_cleaning": parallel_cleaning,
            "dask_address": dask_client.scheduler.address,
        }
        if output_filenames:
            config["output_filenames"] = {
                "psf_image": "test_psf_image",
                "dirty_image": "test_dirty_image",
                "clean_image": "test_clean_image",
                "intermediate_images": "test_partial_cleaned",
                "residual_image": "test_residual_image",
                "model_image": "test_model_image",
            }
        else:
            config["output_filenames"] = "use_default"
        config_filepath = tmp_path / "config.yaml"
        with open(config_filepath, "w") as outfile:
            yaml.dump(config, outfile)
        return config_filepath

    return make_config


@fixture(scope="session")
def xarray_dataset_first_times_first_baselines() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset.

    The returned dataset contains a `UVW` DataArray with `time`, `baseline_id`, `uvw_label`, and `frequency`
    as dimensions. Values are taken from the 'midbands_averaged' dataset and contains the first 10 times and baselines.

    Returns:
        dataset: A minimal xarray Dataset.
    """
    time = np.array(
        [
            1.5138402640055599e09,
            1.5138402720166807e09,
            1.5138402800278015e09,
            1.5138402880389223e09,
            1.5138402960500422e09,
            1.5138403040611629e09,
            1.5138403120722837e09,
            1.5138403200834045e09,
            1.5138403280945253e09,
            1.5138403361056461e09,
        ]
    )

    frequency = np.array(
        [
            1.3837738037109375e08,
            1.3954925537109375e08,
            1.4072113037109375e08,
            1.4189300537109375e08,
            1.4306488037109375e08,
            1.4423675537109375e08,
            1.4540863037109375e08,
            1.4658050537109375e08,
            1.4775238037109375e08,
            1.4892425537109375e08,
        ]
    )

    baseline_id = np.array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])

    uvw_arr = np.array(
        [
            [
                [-112.36791324, -2.76689194, -63.29948311],
                [246.74903409, 258.7643086, 98.59290382],
                [280.06790506, 283.66010606, 113.60626145],
                [383.03047552, 326.77718236, 165.27494701],
                [359.11598545, 261.5326786, 161.89144347],
                [218.11833768, 340.13964079, 69.65789859],
                [248.33538454, 304.42974208, 92.36720758],
                [176.00046812, 149.48652804, 75.51726995],
                [253.09342506, 180.42106216, 114.41498557],
                [288.36775569, 71.85744174, 151.36060696],
            ],
            [
                [-112.38645887, -2.82212765, -63.26411019],
                [246.65268903, 258.88560918, 98.51551281],
                [279.96402908, 283.79778561, 113.51840891],
                [382.92162886, 326.9654755, 165.15472799],
                [359.038185, 261.70921442, 161.77867984],
                [217.97284357, 340.24687002, 69.5896128],
                [248.21460714, 304.55182378, 92.28936856],
                [175.95064732, 149.57304823, 75.46202922],
                [253.04061286, 180.54547911, 114.335509],
                [288.37999265, 71.99919499, 151.26990301],
            ],
            [
                [-112.40496618, -2.87737252, -63.22873149],
                [246.55625994, 259.00686241, 98.43815227],
                [279.86005771, 283.93541411, 113.43058922],
                [382.81265171, 327.15371518, 165.03454345],
                [358.96026219, 261.88571205, 161.6659409],
                [217.82727522, 340.35402771, 69.52137293],
                [248.09374517, 304.67384611, 92.21156769],
                [175.90076657, 149.65954395, 75.40680428],
                [252.98771442, 180.66987013, 114.25604921],
                [288.39213129, 72.14095433, 151.17919536],
            ],
            [
                [-112.42343516, -2.93262652, -63.19334702],
                [246.45974683, 259.12806825, 98.36082222],
                [279.75599097, 284.07299152, 113.34280242],
                [382.70354411, 327.34190132, 164.91439342],
                [358.88221704, 262.06217142, 161.55322669],
                [217.68163267, 340.46111382, 69.453179],
                [247.97279868, 304.79580902, 92.13380502],
                [175.85082587, 149.74601516, 75.35159514],
                [252.93472976, 180.79423518, 114.1766062],
                [288.40417162, 72.28271972, 151.08848405],
            ],
            [
                [-112.44186581, -2.98788964, -63.15795681],
                [246.36314976, 259.24922665, 98.2835227],
                [279.65182893, 284.21051778, 113.25504855],
                [382.59430611, 327.53003386, 164.79427797],
                [358.80404959, 262.23859246, 161.44053726],
                [217.535916, 340.56812831, 69.38503105],
                [247.85176773, 304.91771247, 92.05608056],
                [175.80082525, 149.83246184, 75.29640182],
                [252.88165891, 180.91857422, 114.09718003],
                [288.41611363, 72.4244911, 150.99776912],
            ],
            [
                [-112.46025812, -3.04316186, -63.12256086],
                [246.26646874, 259.37033758, 98.20625372],
                [279.54757159, 284.34799285, 113.16732762],
                [382.48493772, 327.71811274, 164.67419711],
                [358.72575987, 262.41497513, 161.32787264],
                [217.39012522, 340.67507115, 69.3169291],
                [247.73065233, 305.03955642, 91.97839433],
                [175.75076472, 149.91888396, 75.24122433],
                [252.82850187, 181.0428872, 114.0177707],
                [288.42795732, 72.56626843, 150.90705059],
            ],
            [
                [-112.47861209, -3.09844315, -63.08715918],
                [246.16970383, 259.49140099, 98.12901532],
                [279.44321901, 284.48541667, 113.07963966],
                [382.37543901, 327.90613788, 164.5541509],
                [358.64734789, 262.59131935, 161.21523287],
                [217.24426041, 340.78194229, 69.24887316],
                [247.60945254, 305.16134083, 91.90074638],
                [175.7006443, 150.00528148, 75.18606271],
                [252.77525867, 181.16717409, 113.93837825],
                [288.43970267, 72.70805165, 150.8163285],
            ],
            [
                [-112.4969277, -3.1537335, -63.05175179],
                [246.07285503, 259.61241683, 98.05180751],
                [279.33877122, 284.62278922, 112.99198472],
                [382.26580999, 328.09410924, 164.43413938],
                [358.56881368, 262.76762507, 161.10261798],
                [217.09832161, 340.8887417, 69.18086326],
                [247.4881684, 305.28306566, 91.82313672],
                [175.65046401, 150.09165438, 75.13091697],
                [252.72192932, 181.29143483, 113.8590027],
                [288.45134969, 72.84984073, 150.72560287],
            ],
            [
                [-112.51520495, -3.20903289, -63.01633869],
                [245.97592239, 259.73338509, 97.97463034],
                [279.23422824, 284.76011044, 112.90436281],
                [382.15605071, 328.28202674, 164.31416258],
                [358.49015728, 262.94389224, 160.99002801],
                [216.95230886, 340.99546935, 69.11289942],
                [247.36679994, 305.40473087, 91.74556537],
                [175.60022386, 150.17800263, 75.07578711],
                [252.66851385, 181.4156694, 113.77964408],
                [288.46289838, 72.99163561, 150.63487374],
            ],
            [
                [-112.53344384, -3.26434131, -62.98091991],
                [245.87890595, 259.85430569, 97.89748381],
                [279.12959012, 284.89738027, 112.81677397],
                [382.0461612, 328.46989032, 164.19422055],
                [358.4113787, 263.12012079, 160.87746301],
                [216.80622222, 341.1021252, 69.04498167],
                [247.24534721, 305.5263364, 91.66803237],
                [175.54992388, 150.2643262, 75.02067318],
                [252.61501227, 181.53987774, 113.70030242],
                [288.47434872, 73.13343624, 150.54414113],
            ],
        ]
    )

    vis_arr = da.zeros((10, 10, 10, 1, 3))

    da_vis = xr.DataArray(
        vis_arr,
        dims=("time", "baseline_id", "frequency", "polarization", "uvw_label"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX"],
            "uvw_label": UVW_LABEL,
        },
    )

    da_uvw = xr.DataArray(
        uvw_arr,
        dims=("time", "baseline_id", "uvw_label"),
        coords={"time": time, "baseline_id": baseline_id, "uvw_label": UVW_LABEL},
    )

    dataset = xr.Dataset({"VISIBILITY": da_vis, "VISIBILITY_CORRECTED": da_vis, "UVW": da_uvw})

    return dataset


@fixture(scope="session")
def xarray_dataset_first_times_first_baselines_two_polarizations() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset.

    The returned dataset contains a `UVW` DataArray with `time`, `baseline_id`, `uvw_label`, and `frequency`
    as dimensions. Values are taken from the 'midbands_averaged' dataset and contains the first 10 times and baselines.

    Returns:
        dataset: A minimal xarray Dataset.
    """
    time = np.array(
        [
            1.5138402640055599e09,
            1.5138402720166807e09,
            1.5138402800278015e09,
            1.5138402880389223e09,
            1.5138402960500422e09,
            1.5138403040611629e09,
            1.5138403120722837e09,
            1.5138403200834045e09,
            1.5138403280945253e09,
            1.5138403361056461e09,
        ]
    )

    frequency = np.array(
        [
            1.3837738037109375e08,
            1.3954925537109375e08,
            1.4072113037109375e08,
            1.4189300537109375e08,
            1.4306488037109375e08,
            1.4423675537109375e08,
            1.4540863037109375e08,
            1.4658050537109375e08,
            1.4775238037109375e08,
            1.4892425537109375e08,
        ]
    )

    baseline_id = np.array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])

    uvw_arr = np.array(
        [
            [
                [-112.36791324, -2.76689194, -63.29948311],
                [246.74903409, 258.7643086, 98.59290382],
                [280.06790506, 283.66010606, 113.60626145],
                [383.03047552, 326.77718236, 165.27494701],
                [359.11598545, 261.5326786, 161.89144347],
                [218.11833768, 340.13964079, 69.65789859],
                [248.33538454, 304.42974208, 92.36720758],
                [176.00046812, 149.48652804, 75.51726995],
                [253.09342506, 180.42106216, 114.41498557],
                [288.36775569, 71.85744174, 151.36060696],
            ],
            [
                [-112.38645887, -2.82212765, -63.26411019],
                [246.65268903, 258.88560918, 98.51551281],
                [279.96402908, 283.79778561, 113.51840891],
                [382.92162886, 326.9654755, 165.15472799],
                [359.038185, 261.70921442, 161.77867984],
                [217.97284357, 340.24687002, 69.5896128],
                [248.21460714, 304.55182378, 92.28936856],
                [175.95064732, 149.57304823, 75.46202922],
                [253.04061286, 180.54547911, 114.335509],
                [288.37999265, 71.99919499, 151.26990301],
            ],
            [
                [-112.40496618, -2.87737252, -63.22873149],
                [246.55625994, 259.00686241, 98.43815227],
                [279.86005771, 283.93541411, 113.43058922],
                [382.81265171, 327.15371518, 165.03454345],
                [358.96026219, 261.88571205, 161.6659409],
                [217.82727522, 340.35402771, 69.52137293],
                [248.09374517, 304.67384611, 92.21156769],
                [175.90076657, 149.65954395, 75.40680428],
                [252.98771442, 180.66987013, 114.25604921],
                [288.39213129, 72.14095433, 151.17919536],
            ],
            [
                [-112.42343516, -2.93262652, -63.19334702],
                [246.45974683, 259.12806825, 98.36082222],
                [279.75599097, 284.07299152, 113.34280242],
                [382.70354411, 327.34190132, 164.91439342],
                [358.88221704, 262.06217142, 161.55322669],
                [217.68163267, 340.46111382, 69.453179],
                [247.97279868, 304.79580902, 92.13380502],
                [175.85082587, 149.74601516, 75.35159514],
                [252.93472976, 180.79423518, 114.1766062],
                [288.40417162, 72.28271972, 151.08848405],
            ],
            [
                [-112.44186581, -2.98788964, -63.15795681],
                [246.36314976, 259.24922665, 98.2835227],
                [279.65182893, 284.21051778, 113.25504855],
                [382.59430611, 327.53003386, 164.79427797],
                [358.80404959, 262.23859246, 161.44053726],
                [217.535916, 340.56812831, 69.38503105],
                [247.85176773, 304.91771247, 92.05608056],
                [175.80082525, 149.83246184, 75.29640182],
                [252.88165891, 180.91857422, 114.09718003],
                [288.41611363, 72.4244911, 150.99776912],
            ],
            [
                [-112.46025812, -3.04316186, -63.12256086],
                [246.26646874, 259.37033758, 98.20625372],
                [279.54757159, 284.34799285, 113.16732762],
                [382.48493772, 327.71811274, 164.67419711],
                [358.72575987, 262.41497513, 161.32787264],
                [217.39012522, 340.67507115, 69.3169291],
                [247.73065233, 305.03955642, 91.97839433],
                [175.75076472, 149.91888396, 75.24122433],
                [252.82850187, 181.0428872, 114.0177707],
                [288.42795732, 72.56626843, 150.90705059],
            ],
            [
                [-112.47861209, -3.09844315, -63.08715918],
                [246.16970383, 259.49140099, 98.12901532],
                [279.44321901, 284.48541667, 113.07963966],
                [382.37543901, 327.90613788, 164.5541509],
                [358.64734789, 262.59131935, 161.21523287],
                [217.24426041, 340.78194229, 69.24887316],
                [247.60945254, 305.16134083, 91.90074638],
                [175.7006443, 150.00528148, 75.18606271],
                [252.77525867, 181.16717409, 113.93837825],
                [288.43970267, 72.70805165, 150.8163285],
            ],
            [
                [-112.4969277, -3.1537335, -63.05175179],
                [246.07285503, 259.61241683, 98.05180751],
                [279.33877122, 284.62278922, 112.99198472],
                [382.26580999, 328.09410924, 164.43413938],
                [358.56881368, 262.76762507, 161.10261798],
                [217.09832161, 340.8887417, 69.18086326],
                [247.4881684, 305.28306566, 91.82313672],
                [175.65046401, 150.09165438, 75.13091697],
                [252.72192932, 181.29143483, 113.8590027],
                [288.45134969, 72.84984073, 150.72560287],
            ],
            [
                [-112.51520495, -3.20903289, -63.01633869],
                [245.97592239, 259.73338509, 97.97463034],
                [279.23422824, 284.76011044, 112.90436281],
                [382.15605071, 328.28202674, 164.31416258],
                [358.49015728, 262.94389224, 160.99002801],
                [216.95230886, 340.99546935, 69.11289942],
                [247.36679994, 305.40473087, 91.74556537],
                [175.60022386, 150.17800263, 75.07578711],
                [252.66851385, 181.4156694, 113.77964408],
                [288.46289838, 72.99163561, 150.63487374],
            ],
            [
                [-112.53344384, -3.26434131, -62.98091991],
                [245.87890595, 259.85430569, 97.89748381],
                [279.12959012, 284.89738027, 112.81677397],
                [382.0461612, 328.46989032, 164.19422055],
                [358.4113787, 263.12012079, 160.87746301],
                [216.80622222, 341.1021252, 69.04498167],
                [247.24534721, 305.5263364, 91.66803237],
                [175.54992388, 150.2643262, 75.02067318],
                [252.61501227, 181.53987774, 113.70030242],
                [288.47434872, 73.13343624, 150.54414113],
            ],
        ]
    )

    vis_arr = da.zeros((10, 10, 10, 2, 3))

    da_vis = xr.DataArray(
        vis_arr,
        dims=("time", "baseline_id", "frequency", "polarization", "uvw_label"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX", "YY"],
            "uvw_label": UVW_LABEL,
        },
    )

    da_uvw = xr.DataArray(
        uvw_arr,
        dims=("time", "baseline_id", "uvw_label"),
        coords={"time": time, "baseline_id": baseline_id, "uvw_label": UVW_LABEL},
    )

    dataset = xr.Dataset({"VISIBILITY": da_vis, "VISIBILITY_CORRECTED": da_vis, "UVW": da_uvw})

    return dataset


@fixture(scope="session")
def xarray_dataset_last_times_first_baselines() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset.

    The returned dataset contains a `UVW` DataArray with `time`, `baseline_id`, `uvw_label`, and `frequency`
    as dimensions. Values are taken from the 'midbands_averaged' dataset.

    Returns:
        dataset: A minimal xarray Dataset.
    """
    time = np.array(
        [
            1.5138689838730545e09,
            1.5138689918841753e09,
            1.5138689998952951e09,
            1.5138690079064159e09,
            1.5138690159175367e09,
            1.5138690239286575e09,
            1.5138690319397783e09,
            1.5138690399508991e09,
            1.5138690479620190e09,
            1.5138690559731398e09,
        ]
    )

    frequency = np.array(
        [
            1.3837738037109375e08,
            1.3954925537109375e08,
            1.4072113037109375e08,
            1.4189300537109375e08,
            1.4306488037109375e08,
            1.4423675537109375e08,
            1.4540863037109375e08,
            1.4658050537109375e08,
            1.4775238037109375e08,
            1.4892425537109375e08,
        ]
    )

    baseline_id = np.array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])

    uvw_arr = np.array(
        [
            [
                [28.50285921, -124.96512637, 14.57162958],
                [-265.53006581, 230.69811485, 117.6298341],
                [-293.27313719, 263.65117348, 127.61816322],
                [-351.90901582, 371.24270405, 138.3848961],
                [-294.03396285, 355.66180201, 103.05912736],
                [-324.03911426, 184.87484509, 170.1256929],
                [-302.49331669, 224.68929016, 144.54116491],
                [-161.4151212, 170.33772836, 62.89246257],
                [-204.23722148, 251.12673512, 70.15233903],
                [-125.4959308, 308.99833095, 0.53908916],
            ],
            [
                [28.56893756, -124.95109882, 14.56251658],
                [-265.60651908, 230.56730453, 117.71367389],
                [-293.36265785, 263.506697, 127.71077274],
                [-352.04808361, 371.06934907, 138.49608369],
                [-294.17649347, 355.51696364, 103.15208047],
                [-324.07648214, 184.71519707, 170.22789724],
                [-302.55833509, 224.54026479, 144.63663251],
                [-161.47911962, 170.25821372, 62.94346266],
                [-204.33868399, 251.02613066, 70.21690929],
                [-125.6477997, 308.93653564, 0.57894016],
            ],
            [
                [28.63500613, -124.93703876, 14.55338278],
                [-265.68288157, 230.43645652, 117.79753759],
                [-293.45207824, 263.3621764, 127.80341029],
                [-352.18703107, 370.89592557, 138.60731487],
                [-294.31892353, 355.37205505, 103.24507829],
                [-324.11373927, 184.55553058, 170.33011317],
                [-302.62325009, 224.39120735, 144.73212041],
                [-161.54306285, 170.17866754, 62.9944828],
                [-204.44007665, 250.92547622, 70.28151137],
                [-125.79962562, 308.87466556, 0.61883889],
            ],
            [
                [28.7010649, -124.92294617, 14.54422821],
                [-265.75915326, 230.30557087, 117.88142517],
                [-293.54139833, 263.21761172, 127.89607581],
                [-352.32585815, 370.72243361, 138.71858958],
                [-294.46125298, 355.2270763, 103.33812078],
                [-324.15088565, 184.39584568, 170.43234063],
                [-302.68806167, 224.24211789, 144.82762857],
                [-161.60695086, 170.09908986, 63.04552298],
                [-204.54139942, 250.82477184, 70.34614525],
                [-125.95140851, 308.81272074, 0.65878535],
            ],
            [
                [28.76711383, -124.90882107, 14.53505286],
                [-265.83533412, 230.17464762, 117.96533662],
                [-293.63061809, 263.07300301, 127.98876928],
                [-352.46456479, 370.54887325, 138.8299078],
                [-294.60348177, 355.08202744, 103.4312079],
                [-324.18792125, 184.23614243, 170.53457961],
                [-302.7527698, 224.09299646, 144.92315696],
                [-161.67078363, 170.0194807, 63.09658318],
                [-204.64265227, 250.72401755, 70.41081092],
                [-126.10314831, 308.75070119, 0.69877952],
            ],
            [
                [28.83315291, -124.89466345, 14.52585673],
                [-265.91142411, 230.04368682, 118.0492719],
                [-293.7197375, 262.92835033, 128.08149067],
                [-352.60315096, 370.37524454, 138.94126948],
                [-294.74560985, 354.93690852, 103.52433963],
                [-324.22484608, 184.07642087, 170.63683005],
                [-302.81737447, 223.94384312, 145.01870555],
                [-161.73456113, 169.93984009, 63.14766339],
                [-204.74383517, 250.62321338, 70.47550834],
                [-126.25484497, 308.68860695, 0.73882138],
            ],
            [
                [28.89918212, -124.88047334, 14.51663983],
                [-265.98742323, 229.9126885, 118.13323098],
                [-293.80875652, 262.78365372, 128.17423996],
                [-352.74161661, 370.20154754, 139.05267459],
                [-294.88763718, 354.79171958, 103.61751593],
                [-324.26166011, 183.91668105, 170.73909195],
                [-302.88187565, 223.79465791, 145.1142743],
                [-161.79828336, 169.86016805, 63.19876357],
                [-204.84494807, 250.52235937, 70.5402375],
                [-126.40649845, 308.62643801, 0.77891092],
            ],
            [
                [28.96520144, -124.86625072, 14.50740216],
                [-266.06333144, 229.78165272, 118.21721383],
                [-293.89767512, 262.63891323, 128.2670171],
                [-352.87996168, 370.02778232, 139.16412308],
                [-295.0295637, 354.64646067, 103.71073678],
                [-324.29836333, 183.75692304, 170.84136524],
                [-302.94627331, 223.64544089, 145.20986319],
                [-161.86195028, 169.78046461, 63.24988373],
                [-204.94599095, 250.42145555, 70.60499837],
                [-126.55810869, 308.56419442, 0.81904814],
            ],
            [
                [29.03121083, -124.8519956, 14.49814372],
                [-266.13914872, 229.65057953, 118.30122043],
                [-293.98649327, 262.49412891, 128.35982206],
                [-353.01818614, 369.85394893, 139.27561493],
                [-295.17138937, 354.50113185, 103.80400214],
                [-324.33495574, 183.59714689, 170.94364991],
                [-303.01056745, 223.4961921, 145.30547218],
                [-161.92556188, 169.70072981, 63.30102384],
                [-205.04696377, 250.32050195, 70.66979094],
                [-126.70967564, 308.50187619, 0.859233],
            ],
            [
                [29.09721029, -124.837708, 14.48886452],
                [-266.21487504, 229.51946895, 118.38525075],
                [-294.07521095, 262.34930081, 128.45265482],
                [-353.15628993, 369.68004743, 139.38715009],
                [-295.31311415, 354.35573317, 103.89731198],
                [-324.37143731, 183.43735266, 171.04594591],
                [-303.07475803, 223.34691159, 145.40110123],
                [-161.98911813, 169.62096366, 63.35218388],
                [-205.1478665, 250.21949862, 70.73461517],
                [-126.86119924, 308.43948334, 0.89946551],
            ],
        ]
    )

    vis_arr = da.zeros((10, 10, 10, 1, 3))

    da_vis = xr.DataArray(
        vis_arr,
        dims=("time", "baseline_id", "frequency", "polarization", "uvw_label"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX"],
            "uvw_label": UVW_LABEL,
        },
    )

    da_uvw = xr.DataArray(
        uvw_arr,
        dims=("time", "baseline_id", "uvw_label"),
        coords={"time": time, "baseline_id": baseline_id, "uvw_label": UVW_LABEL},
    )

    dataset = xr.Dataset({"VISIBILITY": da_vis, "VISIBILITY_CORRECTED": da_vis, "UVW": da_uvw})

    return dataset


@fixture(scope="session")
def xarray_dataset_first_times_last_baselines() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset.

    The returned dataset contains a `UVW` DataArray with `time`, `baseline_id`, `uvw_label`, and `frequency`
    as dimensions. Values are taken from the 'midbands_averaged' dataset.

    Returns:
        dataset: A minimal xarray Dataset.
    """
    time = np.array(
        [
            1.5138402640055599e09,
            1.5138402720166807e09,
            1.5138402800278015e09,
            1.5138402880389223e09,
            1.5138402960500422e09,
            1.5138403040611629e09,
            1.5138403120722837e09,
            1.5138403200834045e09,
            1.5138403280945253e09,
            1.5138403361056461e09,
        ]
    )

    frequency = np.array(
        [
            1.3837738037109375e08,
            1.3954925537109375e08,
            1.4072113037109375e08,
            1.4189300537109375e08,
            1.4306488037109375e08,
            1.4423675537109375e08,
            1.4540863037109375e08,
            1.4658050537109375e08,
            1.4775238037109375e08,
            1.4892425537109375e08,
        ]
    )

    baseline_id = np.array([1881, 1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890])

    uvw_arr = np.array(
        [
            [
                [-24698.06659772, 10846.26463652, -15762.1864446],
                [-8073.56482313, -14814.95640472, -2223.06466869],
                [17385.21807696, 4079.41078376, 9132.47088428],
                [23083.37200503, 25216.61820541, 8912.31883817],
                [16624.50177458, -25661.22104124, 13539.12177592],
                [42083.28467468, -6766.85385276, 24894.65732888],
                [47781.43860275, 14370.35356889, 24674.50528277],
                [25458.7829001, 18894.36718848, 11355.53555296],
                [31156.93682816, 40031.57461013, 11135.38350686],
                [5698.15392807, 21137.20742165, -220.15204611],
            ],
            [
                [-24708.361769, 10834.12441797, -15754.39870428],
                [-8066.97272159, -14818.92552564, -2220.53960175],
                [17386.08246912, 4087.95687779, 9127.00220887],
                [23073.76436643, 25227.96605208, 8905.08005305],
                [16641.38904741, -25653.04994361, 13533.85910253],
                [42094.44423812, -6746.16754018, 24881.40091315],
                [47782.12613543, 14393.84163411, 24659.47875733],
                [25453.05519071, 18906.88240343, 11347.54181062],
                [31140.73708802, 40046.89157771, 11125.6196548],
                [5687.68189731, 21140.00917429, -221.92215582],
            ],
            [
                [-24718.64851279, 10821.97912695, -15746.60773697],
                [-8060.377873, -14822.89140453, -2218.01661451],
                [17386.94093404, 4096.5034015, 9121.53327113],
                [23064.14886629, 25239.30917646, 8897.84430534],
                [16658.27063979, -25644.87053148, 13528.59112246],
                [42105.58944683, -6725.47572545, 24868.1410081],
                [47782.79737908, 14417.33004951, 24644.45204231],
                [25447.31880704, 18919.39480603, 11339.54988564],
                [31124.52673929, 40062.20058099, 11115.86091985],
                [5677.20793226, 21142.80577496, -223.68896579],
            ],
            [
                [-24728.92682589, 10809.82876725, -15738.8135451],
                [-8053.78027942, -14826.85404015, -2215.49570776],
                [17387.79347144, 4105.05035223, 9116.06407276],
                [23054.52550762, 25250.64757502, 8890.61159731],
                [16675.14654647, -25636.68280741, 13523.31783734],
                [42116.72029733, -6704.77841503, 24854.87761786],
                [47783.45233351, 14440.81880777, 24629.4251424],
                [25441.57375086, 18931.90439238, 11331.55978052],
                [31108.30578703, 40077.50161517, 11106.10730506],
                [5666.73203617, 21145.5972228, -225.45247545],
            ],
            [
                [-24739.19670379, 10797.67334421, -15731.01613209],
                [-8047.17994375, -14830.81343077, -2212.9768826],
                [17388.64008096, 4113.59772622, 9110.59461616],
                [23044.89429463, 25261.98124279, 8883.38193212],
                [16692.01676004, -25628.48677498, 13518.03924949],
                [42127.83678475, -6684.07561799, 24841.61074825],
                [47784.09099841, 14464.30789858, 24614.39806421],
                [25435.82002471, 18944.41115699, 11323.57149876],
                [31092.07423837, 40092.79467356, 11096.35881472],
                [5656.25421366, 21148.38351657, -227.21268404],
            ],
            [
                [-24749.45814397, 10785.51286078, -15723.21549984],
                [-8040.57686759, -14834.76957542, -2210.46013965],
                [17389.48076239, 4122.14552141, 9105.12490267],
                [23035.25522967, 25273.310177, 8876.15531153],
                [16708.88127639, -25620.2824362, 13512.7553602],
                [42138.93890637, -6663.36733938, 24828.34040251],
                [47784.71337364, 14487.79731622, 24599.37081138],
                [25430.05762998, 18956.91509682, 11315.58504232],
                [31075.83209725, 40108.07975242, 11086.61545118],
                [5645.77446728, 21151.1646556, -228.96959113],
            ],
            [
                [-24759.71114215, 10773.34732207, -15715.41165163],
                [-8033.97105371, -14838.72247243, -2207.94547996],
                [17390.31551538, 4130.69373419, 9099.65493457],
                [23025.60831679, 25284.63437291, 8868.93173859],
                [16725.74008844, -25612.06979451, 13507.46617167],
                [42150.02665753, -6642.65358788, 24815.0665862],
                [47785.31945894, 14511.28705084, 24584.34339022],
                [25424.28656909, 18969.41620662, 11307.60041453],
                [31059.5793705, 40123.35684534, 11076.87721855],
                [5635.29280141, 21153.94063872, -230.72319598],
            ],
            [
                [-24769.95569542, 10761.17673152, -15707.60458966],
                [-8027.36250398, -14842.6721207, -2205.43290425],
                [17391.14433969, 4139.24236216, 9094.18471342],
                [23015.95355871, 25295.95382731, 8861.71121532],
                [16742.59319143, -25603.84885222, 13502.17168541],
                [42161.10003511, -6621.93436936, 24801.78930308],
                [47785.90925413, 14534.77709579, 24569.31580498],
                [25418.50684367, 18981.91448286, 11299.61761767],
                [31043.31606269, 40138.62594801, 11067.14411956],
                [5624.80921902, 21156.71146515, -232.4734981],
            ],
            [
                [-24780.19180048, 10749.00109303, -15699.79431644],
                [-8020.75122053, -14846.61851896, -2202.92241331],
                [17391.96723506, 4147.79140256, 9088.71424097],
                [23006.29095854, 25307.26853655, 8854.49374405],
                [16759.44057995, -25595.61961198, 13496.87190313],
                [42172.15903554, -6601.20969047, 24788.50855741],
                [47786.48275902, 14558.26744352, 24554.28806049],
                [25412.71845559, 18994.40992152, 11291.63665429],
                [31027.04217907, 40153.88705551, 11057.41615737],
                [5614.32372348, 21159.47713399, -234.22049692],
            ],
            [
                [-24790.41945304, 10736.82041172, -15691.98083525],
                [-8014.13720613, -14850.56166554, -2200.41400822],
                [17392.78420113, 4156.34085181, 9083.24351952],
                [22996.62052033, 25318.5784959, 8847.27932782],
                [16776.28224691, -25587.38207725, 13491.56682703],
                [42183.20365417, -6580.47955991, 24775.22435477],
                [47787.03997337, 14581.75808419, 24539.26016306],
                [25406.92140726, 19006.90251735, 11283.65752774],
                [31010.75772646, 40169.14016144, 11047.69333603],
                [5603.8363192, 21162.23764409, -235.96419171],
            ],
        ]
    )

    vis_arr = da.zeros((10, 10, 10, 1, 3))

    da_vis = xr.DataArray(
        vis_arr,
        dims=("time", "baseline_id", "frequency", "polarization", "uvw_label"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX"],
            "uvw_label": UVW_LABEL,
        },
    )

    da_uvw = xr.DataArray(
        uvw_arr,
        dims=("time", "baseline_id", "uvw_label"),
        coords={"time": time, "baseline_id": baseline_id, "uvw_label": UVW_LABEL},
    )

    dataset = xr.Dataset({"VISIBILITY": da_vis, "VISIBILITY_CORRECTED": da_vis, "UVW": da_uvw})

    return dataset


@fixture(scope="module")
def example_visibility_partition(
    xarray_dataset_first_times_first_baselines: xr.Dataset,
    xarray_dataset_last_times_first_baselines: xr.Dataset,
    xarray_dataset_first_times_last_baselines: xr.Dataset,
) -> VisibilityPartition:
    """
    Constructs a minimal VisibilityPartition object.

    The returned dataset contains two xarray Datasets, each of which have variables `VISIBILITY`, `UVW`. `VISIBILITY`
    has dimensions `time`, `baseline_id`, `uvw_label`, `frequency`, and `polarization`. `UVW` has dimensions `time`,
    `baseline_id`, and `uvw_label`.

    Returns:
        VisPart: A minimal VisibilityPartition.
    """

    xds1 = xarray_dataset_first_times_first_baselines
    xds2 = xarray_dataset_last_times_first_baselines
    xds3 = xarray_dataset_first_times_last_baselines

    return VisibilityPartition({"xds1": xds1, "xds2": xds2, "xds3": xds3})


@fixture(scope="session")
def xarray_dataset_single_time_frequency_polarization() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset that contains a single time, frequency, and polarization.

    Returns:
        dataset: A minimal xarray Dataset.
    """
    time = np.array([1609743467])

    frequency = np.array(
        [
            1.3856e08,
        ]
    )

    baseline_id = np.array(
        [
            21,
            28,
            35,
            36,
            50,
            52,
            63,
            81,
            83,
            90,
            95,
            115,
            121,
            122,
            125,
            135,
            136,
            151,
            155,
            159,
            163,
            168,
            173,
            175,
            184,
            185,
            200,
            216,
            221,
            229,
            230,
            234,
            236,
            245,
            251,
            257,
            260,
            262,
            269,
            271,
            273,
            293,
            298,
            299,
            300,
            302,
            303,
            315,
            316,
            319,
        ]
    )

    visibilities = np.array(
        [
            [
                [[-0.019302825 + 0.333558917j]],
                [[0.266637027 - 0.03425467j]],
                [[0.018804673 - 0.286405146j]],
                [[0.253863335 + 0.152649358j]],
                [[0.053513464 - 0.138062641j]],
                [[0.214516774 - 0.003123391j]],
                [[-0.41726318 + 0.783933043j]],
                [[0.257863313 + 0.015119202j]],
                [[-2.301162958 - 0.354648143j]],
                [[0.086073428 + 0.026452025j]],
                [[-0.180546552 - 0.126494944j]],
                [[0.088764392 - 0.058507305j]],
                [[0.004388805 + 0.069047555j]],
                [[0.129150748 + 0.08358296j]],
                [[0.559584737 + 0.045768224j]],
                [[0.154344276 + 0.148710519j]],
                [[0.073165402 - 0.049170751j]],
                [[0.033275753 + 0.176684573j]],
                [[0.075686224 - 0.205269843j]],
                [[0.100120656 + 0.118196592j]],
                [[0.226809755 + 0.055601977j]],
                [[0.174696013 - 0.018419899j]],
                [[1.605686784 + 0.922954977j]],
                [[0.202793837 - 0.185874492j]],
                [[-0.03924438 - 0.048234887j]],
                [[-0.761120677 + 1.256177783j]],
                [[-0.039016955 - 0.198100984j]],
                [[0.055056255 - 0.062004317j]],
                [[0.272586495 - 0.237862915j]],
                [[0.402956396 + 0.336832762j]],
                [[0.159074366 - 0.029217394j]],
                [[-0.152835459 + 0.780565858j]],
                [[-0.369118273 + 0.842812836j]],
                [[0.265288889 + 0.108425893j]],
                [[0.360287398 - 0.020387612j]],
                [[-0.147673979 - 0.013792453j]],
                [[-0.176319838 + 1.047961354j]],
                [[0.34144032 + 1.053181648j]],
                [[0.183662623 - 0.062672824j]],
                [[0.131932542 + 0.170758605j]],
                [[0.208299428 - 0.10620898j]],
                [[0.220581517 + 0.120512262j]],
                [[-0.033194572 + 0.062668264j]],
                [[0.227642477 - 0.065612525j]],
                [[0.131967276 - 0.115325049j]],
                [[0.132077619 - 0.018372569j]],
                [[0.35450235 - 1.234943986j]],
                [[0.206519604 - 0.04155134j]],
                [[0.00757323 + 0.007059323j]],
                [[-0.241904333 - 0.027503224j]],
            ]
        ]
    )

    da_vis = xr.DataArray(
        visibilities,
        dims=("time", "baseline_id", "frequency", "polarization"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["RR"],
        },
    )

    dataset = xr.Dataset({"VISIBILITY_CORRECTED": da_vis})

    return dataset


@fixture(scope="session")
def xarray_dataset_single_time_frequency_two_polarizations() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset that contains a single time and frequency, and two polarizations.

    Returns:
        dataset: A minimal xarray Dataset with two polarizations.
    """
    time = np.array([1609743467])

    frequency = np.array(
        [
            1.3856e08,
        ]
    )

    baseline_id = np.array(
        [
            21,
            28,
            35,
            36,
            50,
            52,
            63,
            81,
            83,
            90,
            95,
            115,
            121,
            122,
            125,
            135,
            136,
            151,
            155,
            159,
            163,
            168,
            173,
            175,
            184,
            185,
            200,
            216,
            221,
            229,
            230,
            234,
            236,
            245,
            251,
            257,
            260,
            262,
            269,
            271,
            273,
            293,
            298,
            299,
            300,
            302,
            303,
            315,
            316,
            319,
        ]
    )

    visibilities = np.array(
        [
            [
                [[-0.019302825 + 0.333558917j]],
                [[0.266637027 - 0.03425467j]],
                [[0.018804673 - 0.286405146j]],
                [[0.253863335 + 0.152649358j]],
                [[0.053513464 - 0.138062641j]],
                [[0.214516774 - 0.003123391j]],
                [[-0.41726318 + 0.783933043j]],
                [[0.257863313 + 0.015119202j]],
                [[-2.301162958 - 0.354648143j]],
                [[0.086073428 + 0.026452025j]],
                [[-0.180546552 - 0.126494944j]],
                [[0.088764392 - 0.058507305j]],
                [[0.004388805 + 0.069047555j]],
                [[0.129150748 + 0.08358296j]],
                [[0.559584737 + 0.045768224j]],
                [[0.154344276 + 0.148710519j]],
                [[0.073165402 - 0.049170751j]],
                [[0.033275753 + 0.176684573j]],
                [[0.075686224 - 0.205269843j]],
                [[0.100120656 + 0.118196592j]],
                [[0.226809755 + 0.055601977j]],
                [[0.174696013 - 0.018419899j]],
                [[1.605686784 + 0.922954977j]],
                [[0.202793837 - 0.185874492j]],
                [[-0.03924438 - 0.048234887j]],
                [[-0.761120677 + 1.256177783j]],
                [[-0.039016955 - 0.198100984j]],
                [[0.055056255 - 0.062004317j]],
                [[0.272586495 - 0.237862915j]],
                [[0.402956396 + 0.336832762j]],
                [[0.159074366 - 0.029217394j]],
                [[-0.152835459 + 0.780565858j]],
                [[-0.369118273 + 0.842812836j]],
                [[0.265288889 + 0.108425893j]],
                [[0.360287398 - 0.020387612j]],
                [[-0.147673979 - 0.013792453j]],
                [[-0.176319838 + 1.047961354j]],
                [[0.34144032 + 1.053181648j]],
                [[0.183662623 - 0.062672824j]],
                [[0.131932542 + 0.170758605j]],
                [[0.208299428 - 0.10620898j]],
                [[0.220581517 + 0.120512262j]],
                [[-0.033194572 + 0.062668264j]],
                [[0.227642477 - 0.065612525j]],
                [[0.131967276 - 0.115325049j]],
                [[0.132077619 - 0.018372569j]],
                [[0.35450235 - 1.234943986j]],
                [[0.206519604 - 0.04155134j]],
                [[0.00757323 + 0.007059323j]],
                [[-0.241904333 - 0.027503224j]],
            ]
        ]
    )
    visibilities = np.concatenate((visibilities / 2, visibilities / 2), axis=-1)

    da_vis = xr.DataArray(
        visibilities,
        dims=("time", "baseline_id", "frequency", "polarization"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX", "YY"],
        },
    )
    dataset = xr.Dataset({"VISIBILITY_CORRECTED": da_vis})
    return dataset


@fixture(scope="session")
def xarray_dataset_single_time_frequency_two_polarizations_circular() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset that contains a single time and frequency, and two polarizations.

    Returns:
        dataset: A minimal xarray Dataset with two circular polarizations.
    """
    time = np.array([1609743467])

    frequency = np.array(
        [
            1.3856e08,
        ]
    )

    baseline_id = np.array(
        [
            21,
            28,
            35,
            36,
            50,
            52,
            63,
            81,
            83,
            90,
            95,
            115,
            121,
            122,
            125,
            135,
            136,
            151,
            155,
            159,
            163,
            168,
            173,
            175,
            184,
            185,
            200,
            216,
            221,
            229,
            230,
            234,
            236,
            245,
            251,
            257,
            260,
            262,
            269,
            271,
            273,
            293,
            298,
            299,
            300,
            302,
            303,
            315,
            316,
            319,
        ]
    )

    visibilities = np.array(
        [
            [
                [[-0.019302825 + 0.333558917j]],
                [[0.266637027 - 0.03425467j]],
                [[0.018804673 - 0.286405146j]],
                [[0.253863335 + 0.152649358j]],
                [[0.053513464 - 0.138062641j]],
                [[0.214516774 - 0.003123391j]],
                [[-0.41726318 + 0.783933043j]],
                [[0.257863313 + 0.015119202j]],
                [[-2.301162958 - 0.354648143j]],
                [[0.086073428 + 0.026452025j]],
                [[-0.180546552 - 0.126494944j]],
                [[0.088764392 - 0.058507305j]],
                [[0.004388805 + 0.069047555j]],
                [[0.129150748 + 0.08358296j]],
                [[0.559584737 + 0.045768224j]],
                [[0.154344276 + 0.148710519j]],
                [[0.073165402 - 0.049170751j]],
                [[0.033275753 + 0.176684573j]],
                [[0.075686224 - 0.205269843j]],
                [[0.100120656 + 0.118196592j]],
                [[0.226809755 + 0.055601977j]],
                [[0.174696013 - 0.018419899j]],
                [[1.605686784 + 0.922954977j]],
                [[0.202793837 - 0.185874492j]],
                [[-0.03924438 - 0.048234887j]],
                [[-0.761120677 + 1.256177783j]],
                [[-0.039016955 - 0.198100984j]],
                [[0.055056255 - 0.062004317j]],
                [[0.272586495 - 0.237862915j]],
                [[0.402956396 + 0.336832762j]],
                [[0.159074366 - 0.029217394j]],
                [[-0.152835459 + 0.780565858j]],
                [[-0.369118273 + 0.842812836j]],
                [[0.265288889 + 0.108425893j]],
                [[0.360287398 - 0.020387612j]],
                [[-0.147673979 - 0.013792453j]],
                [[-0.176319838 + 1.047961354j]],
                [[0.34144032 + 1.053181648j]],
                [[0.183662623 - 0.062672824j]],
                [[0.131932542 + 0.170758605j]],
                [[0.208299428 - 0.10620898j]],
                [[0.220581517 + 0.120512262j]],
                [[-0.033194572 + 0.062668264j]],
                [[0.227642477 - 0.065612525j]],
                [[0.131967276 - 0.115325049j]],
                [[0.132077619 - 0.018372569j]],
                [[0.35450235 - 1.234943986j]],
                [[0.206519604 - 0.04155134j]],
                [[0.00757323 + 0.007059323j]],
                [[-0.241904333 - 0.027503224j]],
            ]
        ]
    )
    visibilities = np.concatenate((visibilities / 2, visibilities / 2), axis=-1)

    da_vis = xr.DataArray(
        visibilities,
        dims=("time", "baseline_id", "frequency", "polarization"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["RR", "LL"],
        },
    )
    dataset = xr.Dataset({"VISIBILITY_CORRECTED": da_vis})
    return dataset


@fixture
def psf_3C123():
    """Central PSF of the VLA imaging 3C123 (20B-356_Array_Kuband_calib_selfcal)."""
    psf_array = np.array(
        [
            [
                10927.45780498,
                10962.94538823,
                11171.83392899,
                11761.58574104,
                12824.4918294,
                14286.31616203,
                15905.83360352,
                17329.79262671,
                18189.08801185,
                18207.12447167,
                17285.92206564,
                15541.69377177,
                13277.54666737,
                10901.25029021,
                8813.71080616,
            ],
            [
                11904.75389177,
                12633.69917194,
                13644.64092271,
                15072.20907984,
                16922.68403614,
                19035.6134642,
                21098.05300527,
                22712.46512231,
                23500.72438458,
                23213.08777548,
                21807.47832198,
                19472.63003552,
                16586.03472672,
                13618.38200637,
                11013.20747071,
            ],
            [
                12703.97001471,
                14325.02381981,
                16375.12406511,
                18897.701651,
                21791.68818319,
                24788.98102368,
                27486.08014766,
                29426.99759903,
                30216.30669376,
                29629.03929802,
                27682.72385784,
                24647.16751884,
                20986.44869169,
                17248.72894256,
                13935.75880716,
            ],
            [
                13361.79203609,
                15996.95451519,
                19239.80588174,
                23032.71019414,
                27153.82484701,
                31212.24273507,
                34698.92683296,
                37086.29381091,
                37951.5542843,
                37088.33008662,
                34571.84617594,
                30755.44502094,
                26196.46933326,
                21531.02739117,
                17332.61235897,
            ],
            [
                13950.00245346,
                17613.38524676,
                22079.59733552,
                27190.88625177,
                32602.44330203,
                37795.65495544,
                42148.98583417,
                45054.98531037,
                46054.72412537,
                44952.01319471,
                41872.73468885,
                37249.15045993,
                31730.69058221,
                26044.42803826,
                20843.05673923,
            ],
            [
                14532.63639253,
                19115.56977428,
                24692.72803383,
                31018.51899056,
                37635.69372833,
                43905.62372856,
                49098.26474156,
                52526.04161394,
                53689.30936794,
                52393.71595546,
                48804.88805081,
                43422.33301809,
                36977.254494,
                30280.77763584,
                24062.79512004,
            ],
            [
                15126.34804166,
                20403.76866949,
                26841.85978881,
                34129.2626639,
                41718.74033974,
                48872.02898954,
                54766.48943388,
                58643.87001689,
                59965.55203395,
                58532.88573525,
                54538.27955791,
                48530.87744931,
                41304.37384911,
                33736.20676022,
                26620.10297283,
            ],
            [
                15678.25068014,
                21336.87496339,
                28279.72101103,
                36158.17472275,
                44366.37755058,
                52097.22421194,
                58462.04781533,
                62650.90600298,
                64095.12755458,
                62589.5032146,
                58340.30712408,
                51924.902037,
                44172.97655947,
                36000.77702191,
                28241.31495717,
            ],
            [
                16069.94386106,
                21753.73262137,
                28790.98082708,
                36826.20694748,
                45230.53516393,
                53164.99518399,
                59708.81610768,
                64026.87817345,
                65536.0,
                64026.87820266,
                59708.81632502,
                53164.99583361,
                45230.53646523,
                36826.20900359,
                28790.9835957,
            ],
            [
                16147.89191799,
                21512.04001809,
                28241.31351389,
                36000.77619835,
                44172.9762505,
                51924.90206051,
                58340.30727009,
                62589.50333447,
                64095.1276453,
                62650.9062374,
                58462.04849287,
                52097.22564369,
                44366.37992731,
                36158.17802616,
                28279.72500974,
            ],
            [
                15771.48918126,
                20533.82983809,
                26620.10299233,
                33736.20727481,
                41304.37467012,
                48530.87836351,
                54538.28038887,
                58532.8864271,
                59965.55271155,
                58643.87097877,
                54766.49106298,
                48872.03160753,
                41718.74406259,
                34129.26732243,
                26841.86495283,
            ],
            [
                14863.89774972,
                18842.9358996,
                24062.79672725,
                30280.77964242,
                36977.25670119,
                43422.33522825,
                48804.890132,
                52393.71791767,
                53689.31140461,
                52526.04406975,
                49098.26799956,
                43905.62805064,
                37635.69911209,
                31018.52510667,
                24692.7342784,
            ],
            [
                13449.14313223,
                16580.95780606,
                20843.05993081,
                26044.43158674,
                31730.69434836,
                37249.1543031,
                41872.73852497,
                44952.01706312,
                46054.72821861,
                45054.98993157,
                42148.99128007,
                37795.6613628,
                32602.45052117,
                27190.89380801,
                22079.60450707,
            ],
            [
                11662.6019045,
                13993.8620989,
                17332.61687142,
                21531.03226023,
                26196.47453388,
                30755.45050273,
                34571.85190529,
                37088.33610168,
                37951.56071903,
                37086.30085574,
                34698.93463202,
                31212.25125734,
                27153.83379044,
                23032.71897652,
                19239.81373912,
            ],
            [
                9729.8366209,
                11389.86275333,
                13935.76403927,
                17248.7345446,
                20986.45478478,
                24647.17416545,
                27682.73108034,
                29629.04711871,
                30216.31515667,
                29427.00674365,
                27486.08993449,
                24788.99124411,
                21791.69840434,
                18897.71123825,
                16375.13229411,
            ],
        ]
    )

    return psf_array


@fixture(scope="function")
def pipeline_config_odd_facets_with_image_info(config_file_odd_facets):
    """Pipeline config with image info relating to 3C123."""
    pipeline_config = PipelineConfig(config_file_odd_facets())
    pipeline_config.image_info = ImageInfo(
        phase_centre=PhaseCenter(phase_centre_ra=1.208958666, phase_centre_dec=0.517848003, phase_centre_frame="FK5"),
        pixel_width_arcsec=3.4726412107851e-06,
        pixel_height_arcsec=3.4726412107851e-06,
    )
    return pipeline_config


@fixture(scope="function")
def swiftly_manager_odd_facets(config_file_odd_facets: Callable) -> Swiftly:
    config = PipelineConfig(config_file_odd_facets())
    swiftly_manager = Swiftly(config)
    swiftly_manager._config.swiftly_info.facet_size_effective = 5
    return swiftly_manager


@fixture(scope="function")
def pipeline_config_subgrid_size_16(pipeline_config_odd_facets):
    subgrid_size = 16
    pipeline_config_odd_facets.swiftly_info = replace(
        pipeline_config_odd_facets.swiftly_info, subgrid_size=subgrid_size, subgrid_size_effective=subgrid_size
    )
    return pipeline_config_odd_facets


@fixture(scope="function")
def pipeline_config_odd_facets(config_file_odd_facets: Callable):
    config = PipelineConfig(config_file_odd_facets())
    # Update config so gridder can be tested independently of ProcessingSetManager
    config.processing_set_info = ProcessingSetInfo(
        number_datasets=1,
        number_uvw_partitions=1,
        vis_name="VISIBILITY_CORRECTED",
        min_frequency=1.3856e10,  # old value 1.3856e8. correct value 138377380.37109375
    )
    return config


@fixture(scope="function")
def random_subgrid_data():
    data_shape = (3, 3)
    subgrid_config = MagicMock()
    subgrid_config.off0 = 0
    subgrid_config.off1 = 1
    vis_data = np.random.rand(*data_shape)
    uvw_data = np.random.rand(*data_shape)
    channel_count = data_shape[1]
    start_channels = np.zeros(data_shape)
    end_channels = np.ones(data_shape)
    subgrid_data = {
        "subgrid_config": subgrid_config,
        "vis_data": vis_data,
        "uvw_data": uvw_data,
        "channel_count": channel_count,
        "start_channels": start_channels,
        "end_channels": end_channels,
    }
    return subgrid_data


@fixture(scope="function")
def visibility_bin(random_subgrid_data):
    return VisibilityBin(**random_subgrid_data)


@fixture(scope="function")
def visibility_bin_dask_vis_data(random_subgrid_data):
    random_subgrid_data["vis_data"] = da.from_array(random_subgrid_data["vis_data"])
    return VisibilityBin(**random_subgrid_data)


@fixture(scope="function")
def xarray_dataset_single_time_frequency_two_polarizations_uvw() -> xr.Dataset:
    """
    Constructs a simplified xarray Dataset that contains a single time and frequency, and two polarizations.

    Returns:
        dataset: A minimal xarray Dataset with two polarizations.
    """
    time = np.array([1609743467])

    frequency = np.array(
        [
            1.3856e08,
        ]
    )

    baseline_id = np.array(
        [
            21,
            28,
            35,
            36,
            50,
            52,
            63,
            81,
            83,
            90,
            95,
            115,
            121,
            122,
            125,
            135,
            136,
            151,
            155,
            159,
            163,
            168,
            173,
            175,
            184,
            185,
            200,
            216,
            221,
            229,
            230,
            234,
            236,
            245,
            251,
            257,
            260,
            262,
            269,
            271,
            273,
            293,
            298,
            299,
            300,
            302,
            303,
            315,
            316,
            319,
        ]
    )

    visibilities = np.array(
        [
            [
                [[-0.019302825 + 0.333558917j]],
                [[0.266637027 - 0.03425467j]],
                [[0.018804673 - 0.286405146j]],
                [[0.253863335 + 0.152649358j]],
                [[0.053513464 - 0.138062641j]],
                [[0.214516774 - 0.003123391j]],
                [[-0.41726318 + 0.783933043j]],
                [[0.257863313 + 0.015119202j]],
                [[-2.301162958 - 0.354648143j]],
                [[0.086073428 + 0.026452025j]],
                [[-0.180546552 - 0.126494944j]],
                [[0.088764392 - 0.058507305j]],
                [[0.004388805 + 0.069047555j]],
                [[0.129150748 + 0.08358296j]],
                [[0.559584737 + 0.045768224j]],
                [[0.154344276 + 0.148710519j]],
                [[0.073165402 - 0.049170751j]],
                [[0.033275753 + 0.176684573j]],
                [[0.075686224 - 0.205269843j]],
                [[0.100120656 + 0.118196592j]],
                [[0.226809755 + 0.055601977j]],
                [[0.174696013 - 0.018419899j]],
                [[1.605686784 + 0.922954977j]],
                [[0.202793837 - 0.185874492j]],
                [[-0.03924438 - 0.048234887j]],
                [[-0.761120677 + 1.256177783j]],
                [[-0.039016955 - 0.198100984j]],
                [[0.055056255 - 0.062004317j]],
                [[0.272586495 - 0.237862915j]],
                [[0.402956396 + 0.336832762j]],
                [[0.159074366 - 0.029217394j]],
                [[-0.152835459 + 0.780565858j]],
                [[-0.369118273 + 0.842812836j]],
                [[0.265288889 + 0.108425893j]],
                [[0.360287398 - 0.020387612j]],
                [[-0.147673979 - 0.013792453j]],
                [[-0.176319838 + 1.047961354j]],
                [[0.34144032 + 1.053181648j]],
                [[0.183662623 - 0.062672824j]],
                [[0.131932542 + 0.170758605j]],
                [[0.208299428 - 0.10620898j]],
                [[0.220581517 + 0.120512262j]],
                [[-0.033194572 + 0.062668264j]],
                [[0.227642477 - 0.065612525j]],
                [[0.131967276 - 0.115325049j]],
                [[0.132077619 - 0.018372569j]],
                [[0.35450235 - 1.234943986j]],
                [[0.206519604 - 0.04155134j]],
                [[0.00757323 + 0.007059323j]],
                [[-0.241904333 - 0.027503224j]],
            ]
        ]
    )
    visibilities = np.concatenate((visibilities / 2, visibilities / 2), axis=-1)
    uvw_arr = np.array(
        [
            [-3.302488147e03, -4.552217596e03, 2.283030252e03],
            [-2.438011939e03, -1.012212842e04, 2.723711141e03],
            [-3.074493078e03, -8.509491879e03, 2.782799130e03],
            [2.784462542e03, -2.334635517e04, 2.244192705e03],
            [-5.593144618e03, -5.475958475e03, 3.531520225e03],
            [-4.005611873e03, -6.149651800e03, 2.869778487e03],
            [2.279950696e02, -3.957274282e03, 4.997688782e02],
            [-1.627541385e04, 1.697545533e03, 7.565273720e03],
            [-6.007014570e02, -8.290654500e02, 4.178524994e02],
            [-2.817927140e04, -9.455299311e03, 1.507001674e04],
            [-6.502625952e03, -8.953365680e03, 4.470762178e03],
            [-1.403639834e04, -1.199086213e04, 8.554072382e03],
            [-6.806308705e03, -1.928970164e04, 6.208091469e03],
            [-1.076696760e04, -1.260094900e04, 7.092054378e03],
            [1.704633151e00, 6.767494050e03, -1.048924667e03],
            [2.230386903e04, -1.219293311e04, -8.948332770e03],
            [1.899983655e04, -3.819343019e03, -8.639704099e03],
            [-2.841570020e03, 1.829699626e04, -1.451370368e03],
            [-8.545590853e03, 1.491735137e04, 1.810101580e03],
            [-3.145252773e03, 7.960660299e03, 2.859589219e02],
            [-2.109066905e04, 1.727069934e04, 7.486705578e03],
            [-1.256612857e04, 1.566932037e04, 3.616856402e03],
            [1.113865742e04, 6.259337827e02, -5.457016785e03],
            [-8.562732997e03, -7.317687220e03, 5.231878212e03],
            [-2.110781120e04, -4.964339246e03, 1.090848221e04],
            [1.728657328e03, 2.379183898e03, -1.186115304e03],
            [-1.398286067e04, -9.066515733e01, 6.753111217e03],
            [8.038215827e02, -8.810076735e03, 9.727708428e02],
            [5.694873828e03, 7.843485454e03, -3.921080015e03],
            [3.271297821e03, 3.834022286e03, -2.171719237e03],
            [-1.181906718e04, 2.217097905e03, 5.345950427e03],
            [-2.432723012e03, 4.543773993e02, 1.089752712e03],
            [2.435317579e03, -6.165584319e03, -2.228748884e02],
            [-5.942289581e03, 1.170481237e04, 1.064452632e03],
            [-1.334467490e04, 5.064192347e03, 5.645098560e03],
            [2.372913687e03, -6.013750012e03, -2.216493144e02],
            [1.442007355e03, -3.655219230e03, -1.352418139e02],
            [-8.286965266e02, 3.128208832e03, -8.191637880e01],
            [-5.704020832e03, -3.379644887e03, 3.261471948e03],
            [-1.824909903e04, -1.026296912e03, 8.938075946e03],
            [7.556592612e03, -1.420572068e03, -3.434359460e03],
            [1.967773450e04, 7.934150612e03, -1.067419123e04],
            [-1.254507820e04, 2.353347974e03, 5.676603998e03],
            [-3.304032482e03, 8.373590091e03, 3.086286711e02],
            [4.856963489e03, -1.283780200e03, -2.123759743e03],
            [1.613389416e04, 1.487479940e04, -9.985909653e03],
            [-2.190786161e03, 4.098205628e02, 9.849165667e02],
            [4.891052245e03, 1.665356219e04, -4.893850858e03],
            [1.567471240e04, -2.526610983e03, -7.147421221e03],
            [4.012752277e03, 5.520076720e03, -2.746077881e03],
        ]
    )
    da_vis = xr.DataArray(
        da.from_array(visibilities),
        dims=("time", "baseline_id", "frequency", "polarization"),
        coords={
            "time": time,
            "baseline_id": baseline_id,
            "frequency": frequency,
            "polarization": ["XX", "YY"],
        },
    )
    da_uvw = xr.DataArray(
        np.expand_dims(uvw_arr, 0),
        dims=("time", "baseline_id", "uvw_label"),
        coords={"time": time, "baseline_id": baseline_id, "uvw_label": UVW_LABEL},
    )

    dataset = xr.Dataset({"VISIBILITY": da_vis, "VISIBILITY_CORRECTED": da_vis, "UVW": da_uvw})
    dataset["frequency"] = dataset.frequency.assign_attrs(channel_width={"data": 200000})
    return dataset


@fixture
def gridding_manager(pipeline_config_subgrid_size_16):
    pipeline_config_subgrid_size_16.gridder_info = replace(
        pipeline_config_subgrid_size_16.gridder_info,
        pixel_scale=2.7408653691942517e-07,
        image_scale=0.0002806646138054914,
        image_scale_padded=0.0002806646138054914,
    )
    return Gridder(pipeline_config_subgrid_size_16)
